// C++ header file box_utils.hpp

/*
  By Nathan C. Hearn
     July 31, 2008

  Box-related utilities.
*/


#ifndef BOX_UTILS_HPP
#define BOX_UTILS_HPP


#include <vector>


bool sub_region_enclosed(const std::vector<double> & main_region_min_coords,
			 const std::vector<double> & main_region_max_coords,
			 const std::vector<double> & sub_region_min_coords,
			 const std::vector<double> & sub_region_max_coords);


bool sub_region_enclosed(const std::vector<bool> & periodic_axis_flags,
			 const std::vector<double> & main_region_min_coords,
			 const std::vector<double> & main_region_max_coords,
			 const std::vector<double> & sub_region_min_coords,
			 const std::vector<double> & sub_region_max_coords,
			 const std::vector<double> & periodic_min_coords,
			 const std::vector<double> & periodic_max_coords);


bool regions_exclusive(const std::vector<double> & region1_min_coords,
		       const std::vector<double> & region1_max_coords,
		       const std::vector<double> & region2_min_coords,
		       const std::vector<double> & region2_max_coords);


bool regions_exclusive(const std::vector<bool> & periodic_axis_flags,
		       const std::vector<double> & region1_min_coords,
		       const std::vector<double> & region1_max_coords,
		       const std::vector<double> & region2_min_coords,
		       const std::vector<double> & region2_max_coords,
		       const std::vector<double> & periodic_min_coords,
		       const std::vector<double> & periodic_max_coords);


bool regions_overlap(const std::vector<double> & region1_min_coords,
		     const std::vector<double> & region1_max_coords,
		     const std::vector<double> & region2_min_coords,
		     const std::vector<double> & region2_max_coords);


bool regions_overlap(const std::vector<bool> & periodic_axis_flags,
		     const std::vector<double> & region1_min_coords,
		     const std::vector<double> & region1_max_coords,
		     const std::vector<double> & region2_min_coords,
		     const std::vector<double> & region2_max_coords,
		     const std::vector<double> & periodic_min_coords,
		     const std::vector<double> & periodic_max_coords);


#endif  // BOX_UTILS_HPP
