// C++ header file grid_fft.hpp

/*
  By Nathan C. Hearn
     October 30, 2007

  FFT-related utilities.
*/


#ifndef GRID_FFT_HPP
#define GRID_FFT_HPP


#include <vector>
#include "quickflash_block_blockdata.hpp"


int get_power_spectra(const std::vector<double> & data_vector,
		      std::vector<double> & power_vector);


int get_power_spectra_row(const QuickFlash::Block::BlockData<double> & data_grid,
			  const unsigned int row_index,
			  std::vector<double> & power_vector);


int get_power_spectra_row(const QuickFlash::Block::BlockData<double> & data_grid,
			  QuickFlash::Block::BlockData<double> & power_grid);



#endif  // GRID_FFT_HPP
