#!/usr/bin/env python


# width_pixels = 2273
# height_pixels = 2273


def main() :

    from sys import argv, exit, stderr, stdout
    
    argc = len(argv)

    min_args = int(4)

    if (argc < min_args) :
        stderr.write("Usage: " + argv[0] + " width_pixels height_pixels "
                     + "task_size\n\n")
        exit(1)


    argptr = int(1)


    width_pixels = int(argv[argptr])
    argptr += 1

    if (width_pixels < 1) :
        stderr.write("Error: Width pixels must be positive\n\n")
        exit(-1)

    height_pixels = int(argv[argptr])
    argptr += 1

    if (height_pixels < 1) :
        stderr.write("Error: Height pixels must be positive\n\n")
        exit(-1)

    task_size =  int(argv[argptr])
    argptr += 1

    if (task_size < 1) :
        stderr.write("Error: Task size must be positive\n\n")
        exit(-1)


    num_pixels = width_pixels * height_pixels

    pixel_index = int(0)

    task_index = int(0)

    while (pixel_index < num_pixels) :
        task_pixels = task_size

        if ((task_pixels + pixel_index) > num_pixels) :
            task_pixels = num_pixels - pixel_index

        cmd = str(pixel_index) + " " + str(task_pixels)

        stdout.write(str(task_index) + " " + cmd + "\n")

        pixel_index += task_pixels

        task_index += 1
    
    
if (__name__ == "__main__") :
    main()

