// C++ header file cubic_volume.hpp

/*
  By Nathan C. Hearn
     May 28, 2007

  Tools for detecting overlap fraction between two rectangular volumes.
*/


#ifndef CUBIC_VOLUME_HPP
#define CUBIC_VOLUME_HPP

#include <vector>


bool volumes_overlap(const std::vector<double> & primary_min,
		     const std::vector<double> & primary_max,
		     const std::vector<double> & secondary_min,
		     const std::vector<double> & secondary_max);


bool volumes_overlap(const std::vector<double> & primary_min,
		     const std::vector<double> & primary_max,
		     const std::vector<double> & secondary_min,
		     const std::vector<double> & secondary_max,
		     double & overlap_volume, 
		     std::vector<double> & overlap_center,
		     double & primary_fraction, double & secondary_fraction);

bool volume_enclosed(const std::vector<double> & primary_min,
		     const std::vector<double> & primary_max,
		     const std::vector<double> & sample_min,
		     const std::vector<double> & sample_max);


#endif  // CUBIC_VOLUME_HPP
