// C++ program file file_list.cpp

/*
  By Nathan C. Hearn
     June 1, 2007

  File globbing routines returning std::string objects.
*/


#include "file_list.hpp"
#include <string>
#include <vector>
#include <glob.h>


int get_file_list(const std::string & search_string, 
		  std::vector<std::string> & file_list)
  {
  int ret_val = -1;  // Error state

  glob_t glob_struct;

  if (glob(search_string.c_str(), GLOB_ERR, 0, &glob_struct) == 0)
    {
    const unsigned int num_matches = glob_struct.gl_pathc;

    if (num_matches > 0)
      {
      file_list.resize(num_matches);

      for (unsigned int idx = 0; idx < num_matches; idx++)
	file_list[idx] = glob_struct.gl_pathv[idx];

      ret_val = 0;  // OK
      }
    }

  globfree(&glob_struct);

  return ret_val;
  }
