// C++ header file read_grid_datafile.hpp

/*
  By Nathan C. Hearn
     February 15, 2008

  Reader for ASCII grid datafiles (the same as used by drawimage.py)
*/


#ifndef READ_GRID_DATAFILE_HPP
#define READ_GRID_DATAFILE_HPP


#include <fstream>
#include <string>
#include "quickflash_block_blockdata.hpp"


int read_file_line(std::ifstream & f, std::string & line, 
		   const char comment_marker=0);


void read_grid_datafile(const std::string & filename, 
			QuickFlash::Block::BlockData<double> & grid);


void read_grid_datafile(const char filename[], 
			QuickFlash::Block::BlockData<double> & grid);


#endif  // READ_GRID_DATAFILE_HPP
