// C++ header file star_array.hpp

/*
  By Nathan C. Hearn
     June 14, 2008

  Set of stars and routines to compute composite color.
*/


#ifndef STAR_ARRAY_HPP
#define STAR_ARRAY_HPP


#include <list>
#include "quickflash_color_color.hpp"
#include "star.hpp"


class StarArray
  {
  public :

    StarArray();
    StarArray(const std::list<Star> & source_star_list);
    StarArray(const StarArray & source);

    ~StarArray() { }

    StarArray & operator=(const StarArray & source)
      {
      reset(source);
      return *this;
      }

    void reset();

    void reset(const std::list<Star> & source_star_list);

    void reset(const StarArray & source);

    void add_star_top(const Star & star) { star_list.push_back(star); }
    void add_star_bottom(const Star & star) {star_list.push_front(star); }

    void get_color(const double x, const double y, 
		   QuickFlash::Color::Color & color) const;

  private :

    std::list<Star> star_list;  // Top star is end of list
  };


#endif  // STAR_ARRAY_HPP
